/* iJmax-1 iJmaxra javitva */


#include<stdio.h>
#include<math.h>
#include <stdlib.h>

int main(int iArg, char** cArg){

  FILE *fOutput,  *fInput;
  int  iI, iJ=0, iImax, iJmax;
  double **eStat;
  char **cName,cOutput[30],cProcessname[30],cInput[30];

/* Reading process name*/
    
    if(iArg>1){
	sscanf(cArg[1],"%s",cProcessname);
    }
    else{
	sprintf(cProcessname,"default");
    }

/* opening input files */

    sprintf(cInput,"%s_colord.log",cProcessname);
    if((fInput = fopen(cInput,"r"))){
	printf("%s\n",cInput);
    }
    else{
	printf("Cannot open %s\n",cInput);
    }
   
/* opening output files */

  sprintf(cOutput,"%s_colpic.ps",cProcessname);  
  fOutput = fopen(cOutput,"w");
  



  /* Reading input */
  fscanf(fInput,"%d",&iImax);
  fscanf(fInput,"%d",&iJmax);
  eStat = (double**) malloc(sizeof(double*)*iJmax);
  for(iI = 0; iI < iJmax; iI++){
    eStat[iI] = (double*) malloc(sizeof(double)*iJmax);
  }
  cName = (char**) malloc(sizeof(char*)*iJmax);
  for(iI = 0; iI < iJmax; iI++){
    cName[iI] = (char*) malloc(sizeof(char)*30);
  }

  /*  printf("memory allocated!\n");*/

  for(iI = 0; iI < iJmax; iI++){
    fscanf(fInput,"%s",cName[iI]);
  }
  for(iI = 0; iI < iJmax; iI++){
    for(iJ = 0; iJ < iJmax; iJ++){
      fscanf(fInput,"%lf",&eStat[iI][iJ]);
    }
  }

  /*  printf("read!\n");*/

  fclose(fInput);

  fprintf(fOutput,"%d %d\n", iI,iJ);
  fprintf(fOutput,"%%!PS-Adobe-2.0\n");
  fprintf(fOutput,"%%%%Title: proba.ps\n");
  fprintf(fOutput,"%%%%Creator: Istvan Miklos\n");
  fprintf(fOutput,"%%%%Orientation: Landscape\n");
  fprintf(fOutput,"%%%%Pages: 1\n");
  fprintf(fOutput,"%%%%BoundingBox: 0 0 612 792\n");
  fprintf(fOutput,"%%%%BeginSetup\n");
  fprintf(fOutput,"%%%%IncludeFeature: *PageSize Letter\n");
  fprintf(fOutput,"%%%%EndSetup\n");
  fprintf(fOutput,"%%%%Magnification: 1.0000\n");
  fprintf(fOutput,"%%%%EndComments\n");
  fprintf(fOutput,"/$F2psDict 200 dict def\n");
  fprintf(fOutput,"$F2psDict begin\n");
  fprintf(fOutput,"$F2psDict /mtrx matrix put\n");
  fprintf(fOutput,"/col-1 {0 setgray} bind def\n");
  fprintf(fOutput,"/col0 {0.000 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col1 {1.000 0.300 0.200 srgb} bind def\n");
  fprintf(fOutput,"/col2 {0.000 1.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col3 {0.000 1.000 1.000 srgb} bind def\n");
  fprintf(fOutput,"/col4 {1.000 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col5 {1.000 0.000 1.000 srgb} bind def\n");
  fprintf(fOutput,"/col6 {1.000 1.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col7 {1.000 1.000 1.000 srgb} bind def\n");
  fprintf(fOutput,"/col8 {0.000 0.000 0.560 srgb} bind def\n");
  fprintf(fOutput,"/col9 {0.000 0.000 0.690 srgb} bind def\n");
  fprintf(fOutput,"/col10 {0.000 0.000 0.820 srgb} bind def\n");
  fprintf(fOutput,"/col11 {0.530 0.810 1.000 srgb} bind def\n");
  fprintf(fOutput,"/col12 {0.000 0.560 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col13 {0.000 0.690 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col14 {0.000 0.820 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col15 {0.000 0.560 0.560 srgb} bind def\n");
  fprintf(fOutput,"/col16 {0.000 0.690 0.690 srgb} bind def\n");
  fprintf(fOutput,"/col17 {0.000 0.820 0.820 srgb} bind def\n");
  fprintf(fOutput,"/col18 {0.560 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col19 {0.690 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col20 {0.820 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col21 {0.560 0.000 0.560 srgb} bind def\n");
  fprintf(fOutput,"/col22 {0.690 0.000 0.690 srgb} bind def\n");
  fprintf(fOutput,"/col23 {0.820 0.000 0.820 srgb} bind def\n");
  fprintf(fOutput,"/col24 {0.500 0.190 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col25 {0.630 0.250 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col26 {0.750 0.380 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col27 {1.000 0.500 0.500 srgb} bind def\n");
  fprintf(fOutput,"/col28 {1.000 0.630 0.630 srgb} bind def\n");
  fprintf(fOutput,"/col29 {1.000 0.750 0.750 srgb} bind def\n");
  fprintf(fOutput,"/col30 {1.000 0.880 0.880 srgb} bind def\n");
  fprintf(fOutput,"/col31 {1.000 0.840 0.000 srgb} bind def\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"end\n");
  fprintf(fOutput,"save\n");
  fprintf(fOutput,"newpath 0 792 moveto 0 0 lineto 612 0 lineto 612 792 lineto closepath clip newpath\n");
  fprintf(fOutput,"65.2 63.5 translate\n");
  fprintf(fOutput," 90 rotate\n");
  fprintf(fOutput,"1 -1 scale\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"/cp {closepath} bind def\n");
  fprintf(fOutput,"/ef {eofill} bind def\n");
  fprintf(fOutput,"/gr {grestore} bind def\n");
  fprintf(fOutput,"/gs {gsave} bind def\n");
  fprintf(fOutput,"/sa {save} bind def\n");
  fprintf(fOutput,"/rs {restore} bind def\n");
  fprintf(fOutput,"/l {lineto} bind def\n");
  fprintf(fOutput,"/m {moveto} bind def\n");
  fprintf(fOutput,"/rm {rmoveto} bind def\n");
  fprintf(fOutput,"/n {newpath} bind def\n");
  fprintf(fOutput,"/s {stroke} bind def\n");
  fprintf(fOutput,"/sh {show} bind def\n");
  fprintf(fOutput,"/slc {setlinecap} bind def\n");
  fprintf(fOutput,"/slj {setlinejoin} bind def\n");
  fprintf(fOutput,"/slw {setlinewidth} bind def\n");
  fprintf(fOutput,"/srgb {setrgbcolor} bind def\n");
  fprintf(fOutput,"/rot {rotate} bind def\n");
  fprintf(fOutput,"/sc {scale} bind def\n");
  fprintf(fOutput,"/sd {setdash} bind def\n");
  fprintf(fOutput,"/ff {findfont} bind def\n");
  fprintf(fOutput,"/sf {setfont} bind def\n");
  fprintf(fOutput,"/scf {scalefont} bind def\n");
  fprintf(fOutput,"/sw {stringwidth} bind def\n");
  fprintf(fOutput,"/tr {translate} bind def\n");
  fprintf(fOutput,"/tnt {dup dup currentrgbcolor\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add srgb}\n");
  fprintf(fOutput,"  bind def\n");
  fprintf(fOutput,"/shd {dup dup currentrgbcolor 4 -2 roll mul 4 -2 roll mul\n");
  fprintf(fOutput,"  4 -2 roll mul srgb} bind def\n");
  fprintf(fOutput,"/$F2psBegin {$F2psDict begin /$F2psEnteredState save def} def\n");
  fprintf(fOutput,"/$F2psEnd {$F2psEnteredState restore end} def\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"$F2psBegin\n");
  fprintf(fOutput,"10 setmiterlimit\n");
  fprintf(fOutput," 0.06000 0.06000 sc\n");
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/

  for(iI = 0; iI < iJmax - 1; iI++){
    for(iJ = iI + 1; iJ < iJmax; iJ++){
      if(eStat[iI][iJ] > 10.0/(double)iJmax){
	fprintf(fOutput,"%f slw\n",eStat[iI][iJ]*iJmax);
	fprintf(fOutput,"n %d %d m %d %d l gs col1 s gr \n",
		3500 + (int)(3500*cos(2.0*3.1415*iI/(double)iJmax)),
		3500 + (int)(3500*sin(2.0*3.1415*iI/(double)iJmax)),
		3500 + (int)(3500*cos(2.0*3.1415*iJ/(double)iJmax)),
		3500 + (int)(3500*sin(2.0*3.1415*iJ/(double)iJmax)));
	
      }
    }
  }

  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",800.0/sqrt((double)iJmax));
  for(iI = 0; iI < iJmax; iI++){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%s) col0 sh gr\n",
	    3500 + (int)(3500*cos(2.0*3.1415*iI/(double)iJmax)),
	    3500 + (int)(3500*sin(2.0*3.1415*iI/(double)iJmax)),	    
	    cName[iI]);
    printf("%d %s\n",iI,cName[iI]);
    
  }



  /* at the end */
  fprintf(fOutput,"$F2psEnd\n");
  fprintf(fOutput,"rs\n");
  fprintf(fOutput,"showpage\n");

  for(iI = 0; iI < iJmax; iI++){
    free(eStat[iI]);
    free(cName[iI]);
  }
  free(eStat);
  free(cName);

  return(0);
}
