#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define MAX 101 


int main(int iArg, char** cArg){

  FILE *file1, *file2, *file3, *file4; 
  double eMatrix[MAX][MAX]; 
  int i,i2,j,imax,jmax,iSor[MAX],iOszlop[MAX];
  char cNev[MAX][10],cProcessname[30],cInput[30],cOutput[30]; 

/* Reading process name */ 

    if(iArg > 1){
	sscanf(cArg[1],"%s",cProcessname);
    }
    else{
	sprintf(cProcessname,"default");
    }
    
/* opening input files */
    sprintf(cInput,"%s_rowass.log",cProcessname);
    if((file1=fopen(cInput,"r"))){
}
    else{
	printf("Cannot open %s!\n",cInput);
    }
    sprintf(cInput,"%s_perm.txt",cProcessname);
    if((file2=fopen(cInput,"r"))){
}
    else{
	printf("Cannot open %s!\n",cInput);
    }

/* opening output files */
    sprintf(cOutput,"%s_roword.log",cProcessname);   
    file3=fopen(cOutput,"w");
    sprintf(cOutput,"%s_colord.log",cProcessname);   
    file4=fopen(cOutput,"w");

/* Reading input */
 
    fscanf(file1,"%d",&imax);
    fprintf(file3,"%d\n",imax);
    fscanf(file1,"%d",&jmax);
    fprintf(file3,"%d\n",jmax);
    

  for(i=0;i<imax;i++){
    fscanf(file1,"%s",cNev[i]);
  } 
  i=0; 
  j=0; 
  
  /* Reading matrix */
  
  for(i=0;i<imax;i++){ 
    for(i2=0;i2<imax;i2++){ 
      fscanf(file1,"%lf",&eMatrix[i][i2]); 
    } 
  } 

  /* Reading permutations */

  for(i=0;i<imax;i++){
    fscanf(file2,"%d",&iSor[i]);
  }
  for(j=0;j<jmax;j++){
    fscanf(file2,"%d",&iOszlop[j]);
  }

  for(i=0;i<imax;i++){
    fprintf(file3,"%s\n",cNev[iSor[i]]);
  } 
  
  for(i=0;i<imax;i++){
    for(i2=0;i2<imax;i2++){
      	fprintf(file3,"%f ",eMatrix[iSor[i]][iSor[i2]]);
	fprintf(file4,"%f ",eMatrix[iSor[i]][iSor[i2]]);
      }
    fprintf(file3,"\n");
    }
    
  
  return (0);

}
