#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define MAX 101 


int main(int iArg, char** cArg){

  FILE *file1, *file2, *file3; 
  double eMatrix[MAX][MAX]; 
  int i,j2,j,imax,jmax,iSor[MAX],iOszlop[MAX];
  char cNev[MAX][10],cProcessname[30],cInput[30],cOutput[30]; 

/* Reading process name */ 


    if(iArg > 1){
	sscanf(cArg[1],"%s",cProcessname);
	printf("%s\n",cProcessname);

    }
    else{
	sprintf(cProcessname,"default");
    }
    printf("%s\n",cProcessname);


/* opening input files */

    sprintf(cInput,"%s_colass.log",cProcessname);
    printf("%s\n",cInput);
    if((file1=fopen(cInput,"r"))){
}
    else{
	printf("Cannot open %s!\n",cInput);
    }
    sprintf(cInput,"%s_perm.txt",cProcessname);
    if((file2=fopen(cInput,"r"))){
}
    else{
	printf("Cannot open %s!\n",cInput);
    }

/* opening output files */
    
    sprintf(cOutput,"%s_colord.log",cProcessname);   
    file3=fopen(cOutput,"w");
    printf("%s\n",cOutput);

/* Reading input */
 
    fscanf(file1,"%d",&imax);
    printf("%d\n",imax);
    fprintf(file3,"%d\n",imax);
    fscanf(file1,"%d",&jmax);
    fprintf(file3,"%d\n",jmax);
    printf("%d\n",jmax);

  for(j=0;j<jmax;j++){
    fscanf(file1,"%s",cNev[j]);
    printf("%s\n",cNev[j]);
  } 
  i=0; 
  j=0; 
  
  /* Reading matrix */
  
  for(j=0;j<jmax;j++){ 
    for(j2=0;j2<jmax;j2++){ 
      fscanf(file1,"%lf",&eMatrix[j][j2]);
      printf("%f\n",eMatrix[j][j2]);  
    } 
  } 

  /* Reading permutations */

  for(i=0;i<imax;i++){
    fscanf(file2,"%d",&iSor[i]);
    printf("iSor[i] %d\n", iSor[i]);
  }
  for(j=0;j<jmax;j++){
    fscanf(file2,"%d",&iOszlop[j]);
    printf("iOszlop[j] %d\n", iOszlop[j]);
  }

  for(j=0;j<jmax;j++){
    fprintf(file3,"%s\n",cNev[iOszlop[j]]);
    printf("%s\n",cNev[iOszlop[j]]);
  } 
  
  for(j=0;j<jmax;j++){
    for(j2=0;j2<jmax;j2++){
      	fprintf(file3,"%f ",eMatrix[iOszlop[j]][iOszlop[j2]]);
	
      }
    fprintf(file3,"\n");
    }
    
  
  return (0);

}
