#include <stdlib.h>
#include <stdio.h>
#include <math.h>

int main(int iArg, char** cArg){
    
    FILE *file1, *file2, *file3=NULL;
    
    int a,b,iteration,i,imax,j,jmax,**iSor;
    double **eSzomszed,szumma;
    char cNev[100][10], cProcessname[50],cInput[50],cOutput[50];
    char cLabel; 

/* Reading process name */ 

    if(iArg > 1){
	sscanf(cArg[1],"%s",cProcessname);
    }
    else{
	sprintf(cProcessname,"default");
    }
    
    cLabel = 0;

    if(iArg > 2){
	sscanf(cArg[2],"%s",cInput);
	if(cInput[0] == '-'){
	    if(cInput[1] == 'l'){
		cLabel = 1;
	    }
	    

	}
    }
/* opening input files */
    sprintf(cInput,"%s_rows.log",cProcessname);
    if((file1=fopen(cInput,"r"))){
    }
    else{
	printf("Cannot open %s!\n",cInput);
    }
 

    if(cLabel == 1){

	sprintf(cInput,"%s_rows_lab.txt",cProcessname);
	if((file3=fopen(cInput,"r"))){
	}
	else{
	    printf("Cannot open %s!\n",cInput);
	}
    }
/* opening output files */

    sprintf(cOutput,"%s_rowass.log",cProcessname);
    file2=fopen(cOutput,"w");

/* Reading input files */

    
    fscanf(file1,"%d",&imax);
    printf("%d\n",imax);
    fprintf(file2,"%d\n",imax);
    fscanf(file1,"%d",&jmax);
    /* printf("%d\n",jmax);*/
    fprintf(file2,"%d\n",jmax);


    fscanf(file1,"%d",&iteration);
    /* printf("%d\n",iteration); */

    /* fajnevek beolvasasa es kiiratasa*/

    if(cLabel == 1){    
    
    for(i=0;i<imax;i++){
      fscanf(file3,"%s",cNev[i]);
      fprintf(file2,"%s\n",cNev[i]);
    }
    }
    else{
	for(i=0;i<imax;i++){
	    fprintf(file2,"%d\n",i);
	}
    }

/* Memoria allokacio az asszocialtsagokat tartalmazo matrixnak */ 

    eSzomszed = (double**) malloc(sizeof(double*)*imax);
    for(i = 0; i < imax; i++){
      eSzomszed[i] = (double*) malloc(sizeof(double)*imax);
    }
    iSor = (int**) malloc(sizeof(int*)*iteration);
    for(i = 0; i < iteration; i++){
      iSor[i] = (int*) malloc(sizeof(int)*imax);
    }
    
    for(i=0;i<iteration;i++){
	for(j=0;j<imax;j++){	    
	    fscanf(file1,"%d",&iSor[i][j]);
	    /* fprintf(file2,"sor %d",i);
	       fprintf(file2,"iteracio %d",j);
	       fprintf(file2,"beolv %d\n",iSor[i][j]);*/
	}
    }
    for(a=0;a<imax;a++){
      for(b=0;b<imax;b++){
	eSzomszed[a][b]=0.0;
      }
    }
    
    for(i=0;i<iteration;i++){
      	for(j=0;j<imax-1;j++){
	    
	    a=iSor[i][j];
	    /*fprintf(file2,"a %d",a);*/
	    b=iSor[i][j+1];
	    
	    /*fprintf(file2,"b %d",b);*/
	    
	    eSzomszed[a][b] += 1.0;
	    eSzomszed[b][a] = eSzomszed[a][b];

	    /*fprintf(file2,"szomszed %d\n", eSzomszed[a][b]);*/
	}
    }
    for(a = 0; a < imax; a++){
      eSzomszed[a][a] = 0.00; 
    }
    for(b=0;b<imax-1;b++){
      for(a=b+1;a<imax;a++){
	eSzomszed[a][b]=((eSzomszed[a][b])/((double)(imax-1.0)*(double)iteration))*(double)imax;	
	eSzomszed[b][a]=eSzomszed[a][b]; 
      }
    }
    szumma=0;
    for(b=0;b<imax-1;b++){
	for(a=b+1;a<imax;a++){	    
	    szumma+=eSzomszed[a][b];  
	}
    }
    for(a=0;a<imax;a++){
	for(b=0;b<imax;b++){
    
	    /* fprintf(file2,"a %d",a);
	       fprintf(file2," b %d",b);*/
	     fprintf(file2,"%f ",eSzomszed[a][b]);
	     	}
	fprintf(file2,"\n");
    }
    fprintf(file2,"szumma %f",szumma);
    for(i = 0; i < imax; i++){
	free(eSzomszed[i]);
    }
    for(i = 0; i < iteration; i++){
	free(iSor[i]);
    }
    free(eSzomszed);
    free(iSor);
    return(0);   
}			 
